*DECK MOC2MH
      SUBROUTINE MOC2MH(ITYPEC,NBN,NGRP,NANIS,
     >                  PHI, XCTOT,XCTRC,XCDIA,XCCAT,XCNUF,XCCHI,XCABS,
     >                  DIFF,BETA,REBAL,FLUN,REFKEF,AKFRB,B2VAL,OOL,
     >                  EBMX,IPRT )
      IMPLICIT NONE
      INTEGER ITYPEC,NBN,NGRP,NANIS,IOUT
      INTEGER IGRP,IPRT, JGRP, IS, IPRTB
      INTEGER NSRC, IER
      DOUBLE PRECISION XCTOT(NGRP),XCABS(NGRP),XCCAT(NGRP,0:NANIS,NGRP),
     >        XCNUF(NGRP),XCCHI(NGRP),XCTRC(NGRP),XCDIA(NGRP),
     >        PHI(NGRP),FLUN(NGRP),DIFF(NGRP),BETA(NGRP),
     >        B2VAL,B2
      DOUBLE PRECISION REBAL(NGRP,NGRP+1),SSRC,REFKEF
      DOUBLE PRECISION AKFRB,AKOLD,LOSS,OLOSS,OOL,AFLNOR,DZERO,DONE
      REAL    EBMX
      PARAMETER (IOUT=6,DZERO= 0.0D0, DONE=1.0D0 )
      LOGICAL TKEFF
      IF( ITYPEC .EQ. 4 )THEN
          IPRTB= IPRT
          CALL MOC2BN(NGRP,NANIS,NBN,PHI,
     >                XCTOT,XCTRC,XCDIA,XCCAT,XCNUF,XCCHI,XCABS,
     >                DIFF,BETA,REBAL,FLUN,REFKEF,EBMX,B2,IPRTB )
          B2VAL= B2
          RETURN
      ENDIF
      NSRC=  NGRP+1
      TKEFF= .TRUE.
*
      SSRC=  DZERO
      DO 190 IGRP= 1, NGRP
         DO 193 JGRP= 1, NGRP
            REBAL(IGRP,JGRP)= -XCCAT(JGRP,0,IGRP)
  193    CONTINUE
         REBAL(IGRP,NSRC)= XCCHI(IGRP)
         SSRC= SSRC+REBAL(IGRP,NSRC)
         REBAL(IGRP,IGRP)= (XCTRC(IGRP)-XCDIA(IGRP))
  190 CONTINUE
      CALL ALSBD(NGRP,1,REBAL,IER,NGRP)
      IF( IER.NE.0 ) CALL XABORT(' MOC2MH: SINGULAR REBALANCING MATRIX')
      LOSS=   DZERO
      OLOSS=  DZERO
      AKFRB=  DZERO
      AKOLD=  DZERO
      DO 191 IGRP= 1, NGRP
         AKOLD=  AKOLD + XCNUF(IGRP)*PHI(IGRP)
         AKFRB=  AKFRB + XCNUF(IGRP)*REBAL(IGRP,NSRC)
         TKEFF=  TKEFF.AND.(REBAL(IGRP,NSRC).GT.DZERO)
         IF( REBAL(IGRP,NSRC).LE.DZERO )THEN
            WRITE(IOUT,7000) 'MOC2MH'
         ENDIF
         LOSS =  LOSS  + XCTOT(IGRP)*REBAL(IGRP,NSRC)
         OLOSS = OLOSS + XCTOT(IGRP)*PHI(IGRP)
         DO 195 JGRP= 1, NGRP
            LOSS=  LOSS  - XCCAT(JGRP,0,IGRP)*REBAL(JGRP,NSRC)
            OLOSS= OLOSS - XCCAT(JGRP,0,IGRP)*PHI(JGRP)
  195    CONTINUE
  191 CONTINUE
C      AFLNOR= DONE/AKFRB
C      AFLNOR= AKOLD/AKFRB
C***  IN ORDER TO FIT *DRAGON* NORMALIZATION
      IF( OOL.EQ.DZERO )THEN
         AFLNOR= OLOSS/LOSS
         OOL= OLOSS
      ELSE
         AFLNOR= OOL/LOSS
      ENDIF
C
C     IF WE WANT TO PRODUCE ONE NEUTRON
      DO 196 IGRP= 1, NGRP
         FLUN(IGRP)= REBAL(IGRP,NSRC)*AFLNOR
  196 CONTINUE
      IF( IPRT.GT.1 )THEN
       IS= 1
       WRITE(IOUT,1015) 'ITERATION','SOURCE','LOSS',
     >                           'AFLNOR','K-EFFECTIVE'
       WRITE(IOUT,1010) IS,SSRC,LOSS,AFLNOR,AKFRB
       IF( IPRT.GT.5 )THEN
         WRITE(IOUT,1040) (REBAL(IGRP,NSRC),IGRP=1,NGRP)
       ENDIF
      ENDIF
C
      RETURN
 1015 FORMAT (5X,7A12)
 1010 FORMAT (5X,I12,1P,3E12.5,E13.6)
 1040 FORMAT (7H FLUX  ,2H: ,1P,10E12.5/(9X,10E12.5))
 6000 FORMAT(/' F L U X E S   A N D   H O M O G E N I Z E D   X - S'/
     > 1X,51(1H-))
 6021 FORMAT(1X,'GROUP',4X,'AVERAGE',8X,'TOTAL',7X,
     >'ABSORPTION',5X,'NUSIGF',8X,'FISSION',10X,'SCATTERING X-S'/11X,
     >'FLUX',11X,'X-S',11X,'X-S',10X,'X-S',
     >10X,'SPECTRUM',3X,'WITHIN GROUP',2X,'OUT OF GROUP')
 6023 FORMAT(1X,I4,1P,8E14.5)
 6028 FORMAT(3H I=,I4,2H: ,1P,10E12.4/(9X,10E12.4))
 6029 FORMAT(/' ORDER OF LEGENDRE: ',I2
     > /' SCATTERING TRANSFER X-S (I TOWARD J) IN REGION',I5,1H:
     > //(11X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,
     > I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,
     > 2HJ=,I4))
 7000 FORMAT(1X,A6,': *** WARNING *** REBAL <= 0')
      END
